/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2008 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.action;

import java.util.Date;

import jp.mosp.common.CommonConst;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;

import jp.mosp.kintai.dto.MSyukkinboDto;
import jp.mosp.kintai.vo.AttendanceCheckCardVo;

public class AttendanceCheckCardAction extends AttendanceTotalAction {

	// コマンド
	public static final String CMD_CHECK_CARD_SELECT		= "K1121";
	private static final String CMD_CHECK_CARD_REGIST		= "K1122";
	private static final String CMD_CHECK_CARD_DELETE		= "K1123";

	/**
	 * コンストラクタ
	 */
	public AttendanceCheckCardAction() {
		super();
	}

	public void action() throws Exception {
		// VOの取得
		AttendanceCheckCardVo vo;
		vo = (AttendanceCheckCardVo)getStoredVo(CommonConst.VO_ATTENDANCE_CHECK_CARD);
		if (vo == null) {
			vo = new AttendanceCheckCardVo();
		}
		vo.initVo(cfg, msg, cmd, aspUser, user);
		vo.clearMessage();
		vo.clearErrField();
		storeVo(CommonConst.VO_ATTENDANCE_CHECK_CARD, vo);
		// VO及びフォワード先URLの設定
		setVo(vo);
		setUrl(vo.getRetUrl());
		// DTOの取得
		MSyukkinboDto dto;
		Object objDto = session.getAttribute(MospConst.ATT_DTO);
		dto = objDto instanceof MSyukkinboDto ? (MSyukkinboDto)objDto : null;
		// DBコネクション取得
		getConnection();
		// ユーザー情報取得
		getInfo(user.getUserId());
		// 手当一覧
		vo.aryAllowance = getMosPCodeArray(CommonConst.TID_ALLOWANCE_NAME);
		// 勤務形態プルダウン
		vo.aryPltWorkType = getWorkTypeArrayWithWeekHoliday();
		// 休出区分プルダウン
		vo.aryPltWorkOnHoliday = getMosPCodeArray(CommonConst.TID_WORK_ON_HOLIDAY_TYPE);
		// 出勤時半休区分プルダウン
		vo.aryPltStartHalfHoliday = getMosPCodeArray(CommonConst.TID_HALF_HOLIDAY_TYPE);
		// 遅刻理由プルダウン
		vo.aryPltLateReason = getReasonCodeArray(CommonConst.TID_LATE_REASON);
		// 遅刻証明書プルダウン
		vo.aryPltLateCertificate = getMosPCodeArray(CommonConst.TID_LATE_CERTIFICATE);
		// 退勤時半休区分プルダウン
		vo.aryPltQuitHalfHoliday = getMosPCodeArray(CommonConst.TID_HALF_HOLIDAY_TYPE);
		// 早退理由プルダウン
		vo.aryPltLeaveEarlyReason = getReasonCodeArray(CommonConst.TID_LEAVE_EARLY_REASON);
		// 早退証明書プルダウン
		vo.aryPltLeaveEarlyCertificate = getMosPCodeArray(CommonConst.TID_LEAVE_EARLY_CERTIFICATE);
		// 勤怠管理コマンド
		setSubTitleMenu(vo);
		// コマンド毎の処理
		if (cmd.equals(CMD_CHECK_CARD_SELECT)) {
			// 表示の準備
			setAttendanceInfo(vo);
			// 出勤検索
			dto = searchAttendance(vo);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);			
		} else if (cmd.equals(CMD_CHECK_CARD_REGIST)) {
			vo.setParams(request);
			// 登録
			dto = registAttendance(vo, dto);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
			// 勤怠一覧へ遷移
			setNextCmd(AttendanceListAction.CMD_ATTENDANCE_LIST_RE_SEARCH);
			// メッセージ設定
			request.setAttribute(MospConst.ATT_MESSAGE, MospUtility.getMessage(msg, MospConst.MSG_UPDATE, ""));			
		} else if (cmd.equals(CMD_CHECK_CARD_DELETE)) {
			vo.setParams(request);
			// 削除
			dto = delete(vo, dto);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
			// 勤怠一覧へ遷移
			setNextCmd(AttendanceListAction.CMD_ATTENDANCE_LIST_RE_SEARCH);
			// メッセージ設定
			request.setAttribute(MospConst.ATT_MESSAGE, MospUtility.getMessage(msg, MospConst.MSG_DELETE, ""));			
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
		// 再検索用MenuVoの保存
		setStoreAttendanceMenuVo(vo);
	}

	/**
	 * 出勤検索
	 * @param vo Voインスタンス
	 * @return 取得Dtoインスタンス
	 * @throws Exception
	 */
	private MSyukkinboDto searchAttendance(AttendanceCheckCardVo vo) throws Exception {
		// 勤怠検索
		MSyukkinboDto dto = getSyukkinboInfo(vo.getHidKCode(), vo.getHidDate());
		// VOに情報を設定
		vo.setFields(dto);
		// 表示モードのセット
		setMode(vo, dto);
		// ラベル表示のセット
		vo.setLabelInfo(dto);
		return dto;
	}

	/**
	 * 勤怠登録
	 * @param vo  Voインスタンス
	 * @param dto Dtoインスタンス
	 * @return 登録後再取得Dtoインスタンス
	 * @throws Exception
	 */
	private MSyukkinboDto registAttendance(	AttendanceCheckCardVo vo, MSyukkinboDto dto) throws Exception {
		// パラメータの妥当性確認
		vo.validate();
		// DBコネクションの取得
		if (conn == null) {
			getConnection();
		}
		// 出勤簿用DAO準備 
		prepareMSyukkinboDao();
		if (dto == null) {
			// 勤怠一覧へ戻る(勤怠データが無い場合)
			String errMessage = MospUtility.getMessage(msg, CommonConst.MSG_NO_ATTENDANCE, "");
			addErrMessage(errMessage);
			setNextCmd(AttendanceListAction.CMD_ATTENDANCE_LIST_RE_SEARCH);
			throw new MospException(CommonConst.EX_NO_ATTENDANCE, errMessage);
		} else {
			// 承認済みの場合はメッセージ表示、登録不可
			if (isApproved(dto)) {
				// メッセージ設定
				request.setAttribute(MospConst.ATT_MESSAGE, 
						MospUtility.getMessage(msg, CommonConst.MSG_ALREADY_APPROVED, 
								getMessageDate(vo.getHidYear(), vo.getHidMonth(), vo.getHidDay())		
						)
				);
			} else {
				// UPDATE(セッション保存DTOが存在する場合)
				// 排他確認
				chkExclusive(dto, getSyukkinboInfo(dto.getKCode(), dto.getHizuke(), true), vo);
				// VOの値をセット
				vo.setDtoFields(dto);
				// 自動計算
				runAutoCheckCalc(vo, dto);
				// 更新（全項目）
				syukkinboDao.update(dto);
			}
		}
		// DTOの再取得
		MSyukkinboDto retDto = getSyukkinboInfo(dto.getKCode(), dto.getHizuke());
		chkUpdate(retDto);
		// コミット
		commit();
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_UPDATE, ""));
		return retDto;
	}

	/**
	 * 勤怠項目削除
	 * @param dto
	 * @throws Exception
	 */
	private MSyukkinboDto delete(AttendanceCheckCardVo vo, MSyukkinboDto dto) throws Exception {
		// DBコネクションの取得
		if (conn == null) {
			getConnection();
		}
		// 出勤簿用DAO準備 
		prepareMSyukkinboDao();
		// データ存在確認
		chkExist(dto);
		// 承認済みの場合はメッセージ表示、削除不可
		if (isApproved(dto)) {
			// メッセージ設定
			request.setAttribute(MospConst.ATT_MESSAGE, 
					MospUtility.getMessage(msg, CommonConst.MSG_ALREADY_APPROVED, 
							getMessageDate(vo.getHidYear(), vo.getHidMonth(), vo.getHidDay())
					)
			);
		} else {
			// 削除
			syukkinboDao.delete(dto);
		}
		// DTOの再取得
		MSyukkinboDto retDto = getSyukkinboInfo(dto.getKCode(), dto.getHizuke());
		// コミット
		commit();
		return retDto;
	}

	/**
	 * 自動計算メソッド
	 * @param vo
	 * @param dto
	 * @throws Exception
	 */
	private void runAutoCheckCalc(AttendanceCheckCardVo vo, MSyukkinboDto dto) throws Exception {
		// 対象日取得
		Date targetDay = util.convStringDateToDate(vo.getHidDate());
		// 勤怠日データ取得
		getAttendanceDay(vo.getHidKCode(), targetDay);
		// 自動計算フラグ有りのみ
		if (isAutoCalc) {
			// 初期化
			late 		= 0;				
			work 		= 0;
			leave 		= 0;
			over 		= 0;
			interval 	= 0;
			latenight 	= 0;
			holidaywork = 0;
			// 週休以外
			if (!isWeekHoliday(dto)) {
				// 勤務形態から規定時刻を取得
				getWorkTypeInfo(vo.getPltWorkType());
				// 出勤時刻算出
				int start = util.convStringTimeToIntegerTime(vo.getTxtStartHour(), vo.getTxtStartMin());
				// 退勤時刻算出
				int quit = util.convStringTimeToIntegerTime(vo.getTxtQuitHour(), vo.getTxtQuitMin());
				boolean shankyukbn = isStartHalfHoliday(vo.getPltStartHalfHoliday());
				boolean kyusyukbn = isWorkOnHoliday(vo.getPltWorkOnHoliday());
				boolean thankyukbn = isQuitHalfHoliday(vo.getPltQuitHalfHoliday());
				// 出勤項目の計算
				getCalcStartTime(start, shankyukbn, kyusyukbn);
				// 遅刻時間セット
				dto.setTiJikan(late);
				// 退勤項目の計算
				getCalcQuitTime(start, quit, (shankyukbn || thankyukbn));
				// 勤務時間セット
				dto.setKinmuJi(work);
				// 早退時間セット
				dto.setSoJikan(leave);
				// 残業時間セット
				dto.setZaJikan(over);
				// 休憩時間セット
				dto.setKyukeiJi(interval);
				// 深夜時間セット
				dto.setSnJikan(latenight);
				// 休出時間セット
				if (kyusyukbn) {
					dto.setKsJikan(holidaywork);
				} else {
					dto.setKsJikan(0);
				}
			}
		}
	}

}
